#ifdef ENABLE_AXISTRACE
/* TRACE ADDED BY THE TRACE INSTRUMENTOR TOOL */
#include "../common/AxisTrace.h"
#endif
/*
 *   Copyright 2003-2004 The Apache Software Foundation.
// (c) Copyright IBM Corp. 2004, 2005 All Rights Reserved
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 */

#include <axis/BasicNode.hpp>

AXIS_CPP_NAMESPACE_USE

extern "C" {

#include <axis/GDefine.h>

#include <axis/AxisUserAPI.h>

#include <axis/BasicNode.h>

AXISC_STORAGE_CLASS_INFO AXISCHANDLE axiscGetAttribute(AXISCHANDLE basicNode, AxiscChar * pachPrefix, 
	AxiscChar * pachURI, AxiscChar * pachLocalname) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetAttribute", NULL, 4,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&basicNode),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pachPrefix),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pachURI),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pachLocalname));	  /* AUTOINSERTED TRACE */
	#endif

	BasicNode *bn = (BasicNode*)basicNode;
		{
		#ifdef ENABLE_AXISTRACE
			AXISCHANDLE traceRet = (bn->getAttribute(pachPrefix,pachURI,pachLocalname));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetAttribute", NULL, 0,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return bn->getAttribute(pachPrefix,pachURI,pachLocalname);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO AXISCHANDLE axiscGetFirstAttribute(AXISCHANDLE basicNode) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetFirstAttribute", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&basicNode));	  /* AUTOINSERTED TRACE */
	#endif

	BasicNode *bn = (BasicNode*)basicNode;
		{
		#ifdef ENABLE_AXISTRACE
			AXISCHANDLE traceRet = (bn->getFirstAttribute());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetFirstAttribute", NULL, 0,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return bn->getFirstAttribute();
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO AXISCHANDLE axiscGetLastAttribute(AXISCHANDLE basicNode) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetLastAttribute", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&basicNode));	  /* AUTOINSERTED TRACE */
	#endif

	BasicNode *bn = (BasicNode*)basicNode;
		{
		#ifdef ENABLE_AXISTRACE
			AXISCHANDLE traceRet = (bn->getLastAttribute());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetLastAttribute", NULL, 0,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return bn->getLastAttribute();
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO AXISCHANDLE axiscGetNextAttribute(AXISCHANDLE basicNode) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetNextAttribute", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&basicNode));	  /* AUTOINSERTED TRACE */
	#endif

	BasicNode *bn = (BasicNode*)basicNode;
		{
		#ifdef ENABLE_AXISTRACE
			AXISCHANDLE traceRet = (bn->getNextAttribute());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetNextAttribute", NULL, 0,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return bn->getNextAttribute();
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO AXISCHANDLE axiscGetCurrentAttribute(AXISCHANDLE basicNode) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetCurrentAttribute", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&basicNode));	  /* AUTOINSERTED TRACE */
	#endif

	BasicNode *bn = (BasicNode*)basicNode;
		{
		#ifdef ENABLE_AXISTRACE
			AXISCHANDLE traceRet = (bn->getCurrentAttribute());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetCurrentAttribute", NULL, 0,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return bn->getCurrentAttribute();
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO AXISCHANDLE axiscCreateAttributeBasicNode(AXISCHANDLE basicNode, const AxiscChar * localname, 
	const AxiscChar * prefix, const AxiscChar * uri, const AxiscChar * value) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscCreateAttributeBasicNode", NULL, 5,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&basicNode),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&localname),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&prefix),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&uri),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&value));	  /* AUTOINSERTED TRACE */
	#endif

	BasicNode *bn = (BasicNode*)basicNode;
		{
		#ifdef ENABLE_AXISTRACE
			AXISCHANDLE traceRet = (bn->createAttribute(localname,prefix,uri,value));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscCreateAttributeBasicNode", NULL, 0,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return bn->createAttribute(localname,prefix,uri,value);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO const AxiscChar * axiscGetLocalNameBasicNode(AXISCHANDLE basicNode) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetLocalNameBasicNode", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&basicNode));	  /* AUTOINSERTED TRACE */
	#endif

	BasicNode *bn = (BasicNode*)basicNode;
		{
		#ifdef ENABLE_AXISTRACE
			const AxiscChar* traceRet = (bn->getLocalName());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetLocalNameBasicNode", NULL, 0,
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return bn->getLocalName();
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO int axiscGetNoOfChildrenBasicNode(AXISCHANDLE basicNode) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetNoOfChildrenBasicNode", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&basicNode));	  /* AUTOINSERTED TRACE */
	#endif

	BasicNode *bn = (BasicNode*)basicNode;
		{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (bn->getNoOfChildren());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetNoOfChildrenBasicNode", NULL, 0,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return bn->getNoOfChildren();
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO AXISCHANDLE axiscGetFirstChildBasicNodeBasicNode(AXISCHANDLE basicNode) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetFirstChildBasicNodeBasicNode", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&basicNode));	  /* AUTOINSERTED TRACE */
	#endif

	BasicNode *bn = (BasicNode*)basicNode;
		{
		#ifdef ENABLE_AXISTRACE
			AXISCHANDLE traceRet = (bn->getFirstChild());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetFirstChildBasicNodeBasicNode", NULL, 0,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return bn->getFirstChild();
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO AXISCHANDLE axiscGetLastChildBasicNodeBasicNode(AXISCHANDLE basicNode) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetLastChildBasicNodeBasicNode", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&basicNode));	  /* AUTOINSERTED TRACE */
	#endif

	BasicNode *bn = (BasicNode*)basicNode;
		{
		#ifdef ENABLE_AXISTRACE
			AXISCHANDLE traceRet = (bn->getLastChild());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetLastChildBasicNodeBasicNode", NULL, 0,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return bn->getLastChild();
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO AXISCHANDLE axiscGetChildBasicNodeBasicNode(AXISCHANDLE basicNode, int iChildPosition) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetChildBasicNodeBasicNode", NULL, 2,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&basicNode),
					TRACETYPE_INT, 0, ((void*)&iChildPosition));	  /* AUTOINSERTED TRACE */
	#endif

	BasicNode *bn = (BasicNode*)basicNode;
		{
		#ifdef ENABLE_AXISTRACE
			AXISCHANDLE traceRet = (bn->getChild(iChildPosition));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetChildBasicNodeBasicNode", NULL, 0,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return bn->getChild(iChildPosition);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO int axiscAddChildBasicNode(AXISCHANDLE basicNode, AXISCHANDLE pBasicNode) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscAddChildBasicNode", NULL, 2,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&basicNode),
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&pBasicNode));	  /* AUTOINSERTED TRACE */
	#endif

	BasicNode *bn = (BasicNode*)basicNode;
		{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (bn->addChild((BasicNode*)pBasicNode));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscAddChildBasicNode", NULL, 0,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return bn->addChild((BasicNode*)pBasicNode);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO AXISC_NODE_TYPE axiscGetNodeType(AXISCHANDLE basicNode) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetNodeType", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&basicNode));	  /* AUTOINSERTED TRACE */
	#endif

	BasicNode *bn = (BasicNode*)basicNode;
		{
		#ifdef ENABLE_AXISTRACE
			AXISC_NODE_TYPE traceRet = ((AXISC_NODE_TYPE)bn->getNodeType());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetNodeType", NULL, 0,
					TRACETYPE_DATA, sizeof(AXISC_NODE_TYPE), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return (AXISC_NODE_TYPE)bn->getNodeType();
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO const AxiscChar * axiscGetValueBasicNode(AXISCHANDLE basicNode) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetValueBasicNode", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&basicNode));	  /* AUTOINSERTED TRACE */
	#endif

	BasicNode *bn = (BasicNode*)basicNode;
		{
		#ifdef ENABLE_AXISTRACE
			const AxiscChar* traceRet = (bn->getValue());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetValueBasicNode", NULL, 0,
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return bn->getValue();
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO int axiscSetValueBasicNode(AXISCHANDLE basicNode, const AxiscChar * pachValue) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscSetValueBasicNode", NULL, 2,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&basicNode),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pachValue));	  /* AUTOINSERTED TRACE */
	#endif

	BasicNode *bn = (BasicNode*)basicNode;
		{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (bn->setValue(pachValue));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscSetValueBasicNode", NULL, 0,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return bn->setValue(pachValue);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO int axiscSetURIBasicNode(AXISCHANDLE basicNode, const AxiscChar * sURI) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscSetURIBasicNode", NULL, 2,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&basicNode),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&sURI));	  /* AUTOINSERTED TRACE */
	#endif

	BasicNode *bn = (BasicNode*)basicNode;
		{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (bn->setURI(sURI));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscSetURIBasicNode", NULL, 0,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return bn->setURI(sURI);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO int axiscSetLocalNameBasicNode(AXISCHANDLE basicNode, const AxiscChar * sLocalName) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscSetLocalNameBasicNode", NULL, 2,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&basicNode),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&sLocalName));	  /* AUTOINSERTED TRACE */
	#endif

	BasicNode *bn = (BasicNode*)basicNode;
		{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (bn->setLocalName(sLocalName));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscSetLocalNameBasicNode", NULL, 0,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return bn->setLocalName(sLocalName);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO int axiscSetPrefixBasicNode(AXISCHANDLE basicNode, const AxiscChar * sPrefix) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscSetPrefixBasicNode", NULL, 2,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&basicNode),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&sPrefix));	  /* AUTOINSERTED TRACE */
	#endif

	BasicNode *bn = (BasicNode*)basicNode;
		{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (bn->setPrefix(sPrefix));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscSetPrefixBasicNode", NULL, 0,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return bn->setPrefix(sPrefix);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO const AxiscChar * axiscGetURIBasicNode(AXISCHANDLE basicNode) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetURIBasicNode", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&basicNode));	  /* AUTOINSERTED TRACE */
	#endif

	BasicNode *bn = (BasicNode*)basicNode;
		{
		#ifdef ENABLE_AXISTRACE
			const AxiscChar* traceRet = (bn->getURI());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetURIBasicNode", NULL, 0,
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return bn->getURI();
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO const AxiscChar * axiscGetPrefixBasicNode(AXISCHANDLE basicNode) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetPrefixBasicNode", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&basicNode));	  /* AUTOINSERTED TRACE */
	#endif

	BasicNode *bn = (BasicNode*)basicNode;
		{
		#ifdef ENABLE_AXISTRACE
			const AxiscChar* traceRet = (bn->getPrefix());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetPrefixBasicNode", NULL, 0,
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return bn->getPrefix();
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO AXISCHANDLE axiscCloneBasicNodeBasicNode(AXISCHANDLE basicNode) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscCloneBasicNodeBasicNode", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&basicNode));	  /* AUTOINSERTED TRACE */
	#endif

	BasicNode *bn = (BasicNode*)basicNode;
		{
		#ifdef ENABLE_AXISTRACE
			AXISCHANDLE traceRet = (bn->clone());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscCloneBasicNodeBasicNode", NULL, 0,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return bn->clone();
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO void axiscDestroyBasicNode(AXISCHANDLE basicNode) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscDestroyBasicNode", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&basicNode));	  /* AUTOINSERTED TRACE */
	#endif

	BasicNode *bn = (BasicNode*)basicNode;
	delete bn;
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscDestroyBasicNode", NULL, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

}

