#ifdef ENABLE_AXISTRACE
/* TRACE ADDED BY THE TRACE INSTRUMENTOR TOOL */
#include "../../common/AxisTrace.h"
#endif
/*
 *   Copyright 2003-2004 The Apache Software Foundation.
// (c) Copyright IBM Corp. 2004, 2005 All Rights Reserved
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 */

#include <axis/client/Stub.hpp>

AXIS_CPP_NAMESPACE_START

class StubC : Stub
{

public :
	StubC(const char *ep, AXIS_PROTOCOL_TYPE pt):Stub(ep,pt) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("StubC", "StubC", NULL, 2,
					TRACETYPE_STRING, 0, ((void*)&ep),
					TRACETYPE_DATA, sizeof(AXIS_PROTOCOL_TYPE), ((void*)&pt));	  /* AUTOINSERTED TRACE */
	#endif
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("StubC", "StubC", NULL, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}
	virtual ~StubC() {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("StubC", "~StubC", NULL, 0);	  /* AUTOINSERTED TRACE */
	#endif
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("StubC", "~StubC", NULL, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}
	Call* getCallStubC() {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("StubC", "getCallStubC", NULL, 0);	  /* AUTOINSERTED TRACE */
	#endif
 	{
		#ifdef ENABLE_AXISTRACE
			Call* traceRet = (getCall());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("StubC", "getCallStubC", NULL, 0,
					TRACETYPE_POINTER, sizeof(Call), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return getCall();
		#endif
	}
 }
	void applyUserPreferencesStubC() {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("StubC", "applyUserPreferencesStubC", NULL, 0);	  /* AUTOINSERTED TRACE */
	#endif
 applyUserPreferences(); 	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("StubC", "applyUserPreferencesStubC", NULL, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}
	void setSOAPHeadersStubC() {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("StubC", "setSOAPHeadersStubC", NULL, 0);	  /* AUTOINSERTED TRACE */
	#endif
 setSOAPHeaders(); 	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("StubC", "setSOAPHeadersStubC", NULL, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

};

AXIS_CPP_NAMESPACE_END

AXIS_CPP_NAMESPACE_USE

extern "C" {

#include <axis/GDefine.h>

#include <axis/AxisUserAPI.h>

#include <axis/client/Stub.h>

AXISC_STORAGE_CLASS_INFO AXISCHANDLE axiscCreateStub(const char * pcEndPointURI, 
	AXISC_PROTOCOL_TYPE eProtocol) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscCreateStub", NULL, 2,
					TRACETYPE_STRING, 0, ((void*)&pcEndPointURI),
					TRACETYPE_DATA, sizeof(AXISC_PROTOCOL_TYPE), ((void*)&eProtocol));	  /* AUTOINSERTED TRACE */
	#endif

	StubC *stub = new StubC(pcEndPointURI, (AXIS_PROTOCOL_TYPE)eProtocol);
		{
		#ifdef ENABLE_AXISTRACE
			AXISCHANDLE traceRet = ((AXISCHANDLE)stub);
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscCreateStub", NULL, 0,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return (AXISCHANDLE)stub;
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO void axiscDestroyStub(AXISCHANDLE stub) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscDestroyStub", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&stub));	  /* AUTOINSERTED TRACE */
	#endif

	StubC *s = (StubC*)stub;
	delete s;
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscDestroyStub", NULL, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

AXISC_STORAGE_CLASS_INFO void axiscSetEndPoint(AXISCHANDLE stub, const char * pcEndPointURI) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscSetEndPoint", NULL, 2,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&stub),
					TRACETYPE_STRING, 0, ((void*)&pcEndPointURI));	  /* AUTOINSERTED TRACE */
	#endif

	Stub *s = (Stub*)stub;
	s->setEndPoint(pcEndPointURI);
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscSetEndPoint", NULL, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

AXISC_STORAGE_CLASS_INFO void axiscSetTransportPropertyStub(AXISCHANDLE stub, const char * pcKey, 
	const char * pcValue) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscSetTransportPropertyStub", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&stub),
					TRACETYPE_STRING, 0, ((void*)&pcKey),
					TRACETYPE_STRING, 0, ((void*)&pcValue));	  /* AUTOINSERTED TRACE */
	#endif

	Stub *s = (Stub*)stub;
	s->setTransportProperty(pcKey,pcValue);
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscSetTransportPropertyStub", NULL, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

AXISC_STORAGE_CLASS_INFO const char * axiscGetTransportPropertyStub(AXISCHANDLE stub, const char *key, 
	AxiscBool response) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetTransportPropertyStub", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&stub),
					TRACETYPE_STRING, 0, ((void*)&key),
					TRACETYPE_DATA, sizeof(AxiscBool), ((void*)&response));	  /* AUTOINSERTED TRACE */
	#endif

	Stub *s = (Stub*)stub;
		{
		#ifdef ENABLE_AXISTRACE
			const char* traceRet = (s->getTransportProperty(key, (bool)(response !=0 )));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetTransportPropertyStub", NULL, 0,
					TRACETYPE_STRING, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return s->getTransportProperty(key, (bool)(response !=0 ));
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO const char * axiscGetFirstTransportPropertyKey(AXISCHANDLE stub, AxiscBool response) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetFirstTransportPropertyKey", NULL, 2,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&stub),
					TRACETYPE_DATA, sizeof(AxiscBool), ((void*)&response));	  /* AUTOINSERTED TRACE */
	#endif

	Stub *s = (Stub*)stub;
		{
		#ifdef ENABLE_AXISTRACE
			const char* traceRet = (s->getFirstTransportPropertyKey( (bool)(response!=0)));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetFirstTransportPropertyKey", NULL, 0,
					TRACETYPE_STRING, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return s->getFirstTransportPropertyKey( (bool)(response!=0));
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO const char * axiscGetNextTransportPropertyKey(AXISCHANDLE stub, AxiscBool response) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetNextTransportPropertyKey", NULL, 2,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&stub),
					TRACETYPE_DATA, sizeof(AxiscBool), ((void*)&response));	  /* AUTOINSERTED TRACE */
	#endif

	Stub *s = (Stub*)stub;
		{
		#ifdef ENABLE_AXISTRACE
			const char* traceRet = (s->getNextTransportPropertyKey((bool)(response!=0)));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetNextTransportPropertyKey", NULL, 0,
					TRACETYPE_STRING, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return s->getNextTransportPropertyKey((bool)(response!=0));
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO const char * axiscGetCurrentTransportPropertyKey(AXISCHANDLE stub, AxiscBool response) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetCurrentTransportPropertyKey", NULL, 2,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&stub),
					TRACETYPE_DATA, sizeof(AxiscBool), ((void*)&response));	  /* AUTOINSERTED TRACE */
	#endif

	Stub *s = (Stub*)stub;
		{
		#ifdef ENABLE_AXISTRACE
			const char* traceRet = (s->getCurrentTransportPropertyKey((bool)(response!=0)));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetCurrentTransportPropertyKey", NULL, 0,
					TRACETYPE_STRING, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return s->getCurrentTransportPropertyKey((bool)(response!=0));
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO const char * axiscGetCurrentTransportPropertyValue(AXISCHANDLE stub, AxiscBool response) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetCurrentTransportPropertyValue", NULL, 2,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&stub),
					TRACETYPE_DATA, sizeof(AxiscBool), ((void*)&response));	  /* AUTOINSERTED TRACE */
	#endif

	Stub *s = (Stub*)stub;
		{
		#ifdef ENABLE_AXISTRACE
			const char* traceRet = (s->getCurrentTransportPropertyValue((bool)(response!=0)));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetCurrentTransportPropertyValue", NULL, 0,
					TRACETYPE_STRING, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return s->getCurrentTransportPropertyValue((bool)(response!=0));
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO void axiscDeleteCurrentTransportProperty(AXISCHANDLE stub, AxiscBool response) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscDeleteCurrentTransportProperty", NULL, 2,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&stub),
					TRACETYPE_DATA, sizeof(AxiscBool), ((void*)&response));	  /* AUTOINSERTED TRACE */
	#endif

	Stub *s = (Stub*)stub;
	s->deleteCurrentTransportProperty((bool)(response!=0));
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscDeleteCurrentTransportProperty", NULL, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

AXISC_STORAGE_CLASS_INFO void axiscDeleteTransportProperty(AXISCHANDLE stub, char * pcKey, 
	unsigned int uiOccurance) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscDeleteTransportProperty", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&stub),
					TRACETYPE_STRING, 0, ((void*)&pcKey),
					TRACETYPE_UINT, 0, ((void*)&uiOccurance));	  /* AUTOINSERTED TRACE */
	#endif

	Stub *s = (Stub*)stub;
	s->deleteTransportProperty(pcKey,uiOccurance);
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscDeleteTransportProperty", NULL, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

AXISC_STORAGE_CLASS_INFO void axiscSetHandlerPropertyStub(AXISCHANDLE stub, AxiscChar * name, 
	void * value, int len) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscSetHandlerPropertyStub", NULL, 4,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&stub),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&name),
					TRACETYPE_POINTER, 1, ((void*)&value),
					TRACETYPE_INT, 0, ((void*)&len));	  /* AUTOINSERTED TRACE */
	#endif

	Stub *s = (Stub*)stub;
	s->setHandlerProperty(name,value,len);
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscSetHandlerPropertyStub", NULL, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

AXISC_STORAGE_CLASS_INFO AXISCHANDLE axiscCreateSOAPHeaderBlock(AXISCHANDLE stub, AxiscChar * pachLocalName, 
	AxiscChar * pachUri, AxiscChar * pachPrefix) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscCreateSOAPHeaderBlock", NULL, 4,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&stub),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pachLocalName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pachUri),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pachPrefix));	  /* AUTOINSERTED TRACE */
	#endif

	Stub *s = (Stub*)stub;
		{
		#ifdef ENABLE_AXISTRACE
			AXISCHANDLE traceRet = ((AXISCHANDLE)s->createSOAPHeaderBlock(pachLocalName,pachUri,pachPrefix));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscCreateSOAPHeaderBlock", NULL, 0,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return (AXISCHANDLE)s->createSOAPHeaderBlock(pachLocalName,pachUri,pachPrefix);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO AXISCHANDLE axiscGetFirstSOAPHeaderBlock(AXISCHANDLE stub) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetFirstSOAPHeaderBlock", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&stub));	  /* AUTOINSERTED TRACE */
	#endif

	Stub *s = (Stub*)stub;
		{
		#ifdef ENABLE_AXISTRACE
			AXISCHANDLE traceRet = ((AXISCHANDLE)s->getFirstSOAPHeaderBlock());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetFirstSOAPHeaderBlock", NULL, 0,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return (AXISCHANDLE)s->getFirstSOAPHeaderBlock();
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO AXISCHANDLE axiscGetNextSOAPHeaderBlock(AXISCHANDLE stub) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetNextSOAPHeaderBlock", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&stub));	  /* AUTOINSERTED TRACE */
	#endif

	Stub *s = (Stub*)stub;
		{
		#ifdef ENABLE_AXISTRACE
			AXISCHANDLE traceRet = ((AXISCHANDLE)s->getNextSOAPHeaderBlock());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetNextSOAPHeaderBlock", NULL, 0,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return (AXISCHANDLE)s->getNextSOAPHeaderBlock();
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO AXISCHANDLE axiscGetCurrentSOAPHeaderBlock(AXISCHANDLE stub) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetCurrentSOAPHeaderBlock", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&stub));	  /* AUTOINSERTED TRACE */
	#endif

	Stub *s = (Stub*)stub;
		{
		#ifdef ENABLE_AXISTRACE
			AXISCHANDLE traceRet = ((AXISCHANDLE)s->getCurrentSOAPHeaderBlock());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetCurrentSOAPHeaderBlock", NULL, 0,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return (AXISCHANDLE)s->getCurrentSOAPHeaderBlock();
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO void axiscDeleteCurrentSOAPHeaderBlock(AXISCHANDLE stub) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscDeleteCurrentSOAPHeaderBlock", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&stub));	  /* AUTOINSERTED TRACE */
	#endif

	Stub *s = (Stub*)stub;
	s->deleteCurrentSOAPHeaderBlock();
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscDeleteCurrentSOAPHeaderBlock", NULL, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

AXISC_STORAGE_CLASS_INFO void axiscDeleteSOAPHeaderBlock(AXISCHANDLE stub, AXISCHANDLE pHeaderBlock) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscDeleteSOAPHeaderBlock", NULL, 2,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&stub),
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&pHeaderBlock));	  /* AUTOINSERTED TRACE */
	#endif

	Stub *s = (Stub*)stub;
	s->deleteSOAPHeaderBlock((IHeaderBlock*)pHeaderBlock);
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscDeleteSOAPHeaderBlock", NULL, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

AXISC_STORAGE_CLASS_INFO void axiscSetProxyStub(AXISCHANDLE stub, const char * pcProxyHost, 
	unsigned int uiProxyPort) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscSetProxyStub", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&stub),
					TRACETYPE_STRING, 0, ((void*)&pcProxyHost),
					TRACETYPE_UINT, 0, ((void*)&uiProxyPort));	  /* AUTOINSERTED TRACE */
	#endif

	Stub *s = (Stub*)stub;
	s->setProxy(pcProxyHost,uiProxyPort);
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscSetProxyStub", NULL, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

AXISC_STORAGE_CLASS_INFO void axiscSetTransportTimeout(AXISCHANDLE stub, const long lSeconds) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscSetTransportTimeout", NULL, 2,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&stub),
					TRACETYPE_LONG, 0, ((void*)&lSeconds));	  /* AUTOINSERTED TRACE */
	#endif

	Stub *s = (Stub*)stub;
	s->setTransportTimeout(lSeconds);
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscSetTransportTimeout", NULL, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

AXISC_STORAGE_CLASS_INFO int axiscGetStatusStub(AXISCHANDLE stub) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetStatusStub", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&stub));	  /* AUTOINSERTED TRACE */
	#endif

	Stub *s = (Stub*)stub;
		{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (s->getStatus());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetStatusStub", NULL, 0,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return s->getStatus();
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO void axiscSetMaintainSession(AXISCHANDLE stub, AxiscBool bSession) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscSetMaintainSession", NULL, 2,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&stub),
					TRACETYPE_DATA, sizeof(AxiscBool), ((void*)&bSession));	  /* AUTOINSERTED TRACE */
	#endif

	Stub *s = (Stub*)stub;
	s->setMaintainSession(0!=bSession);
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscSetMaintainSession", NULL, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

AXISC_STORAGE_CLASS_INFO void axiscSetTransportProtocol(AXISCHANDLE stub, AXISC_PROTOCOL_TYPE eProtocol) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscSetTransportProtocol", NULL, 2,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&stub),
					TRACETYPE_DATA, sizeof(AXISC_PROTOCOL_TYPE), ((void*)&eProtocol));	  /* AUTOINSERTED TRACE */
	#endif

	Stub *s = (Stub*)stub;
	s->setTransportProtocol((AXIS_PROTOCOL_TYPE)eProtocol);
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscSetTransportProtocol", NULL, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

AXISC_STORAGE_CLASS_INFO AXISC_PROTOCOL_TYPE axiscGetTransportProtocol(AXISCHANDLE stub) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetTransportProtocol", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&stub));	  /* AUTOINSERTED TRACE */
	#endif

	Stub *s = (Stub*)stub;
		{
		#ifdef ENABLE_AXISTRACE
			AXISC_PROTOCOL_TYPE traceRet = ((AXISC_PROTOCOL_TYPE)(s->getTransportProtocol()));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetTransportProtocol", NULL, 0,
					TRACETYPE_DATA, sizeof(AXISC_PROTOCOL_TYPE), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return (AXISC_PROTOCOL_TYPE)(s->getTransportProtocol());
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO AXISCHANDLE axiscGetCall(AXISCHANDLE stub) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetCall", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&stub));	  /* AUTOINSERTED TRACE */
	#endif
 
	StubC *s = (StubC*)stub;
		{
		#ifdef ENABLE_AXISTRACE
			AXISCHANDLE traceRet = (s->getCallStubC());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetCall", NULL, 0,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return s->getCallStubC();
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO void axiscApplyUserPreferences(AXISCHANDLE stub) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscApplyUserPreferences", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&stub));	  /* AUTOINSERTED TRACE */
	#endif
 
	StubC *s = (StubC*)stub;
	s->applyUserPreferencesStubC(); 
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscApplyUserPreferences", NULL, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

AXISC_STORAGE_CLASS_INFO void axiscSetSOAPHeaders(AXISCHANDLE stub) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscSetSOAPHeaders", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&stub));	  /* AUTOINSERTED TRACE */
	#endif
 
	StubC *s = (StubC*)stub;
	s->setSOAPHeadersStubC(); 
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscSetSOAPHeaders", NULL, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

}

