#ifdef ENABLE_AXISTRACE
/* TRACE ADDED BY THE TRACE INSTRUMENTOR TOOL */
#include "../common/AxisTrace.h"
#endif
/*
 *   Copyright 2003-2004 The Apache Software Foundation.
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 *
 * @author Dinesh Premalal (xydinesh@gmail.com)
 *
 */

#include "unicode.hpp"

#include <stdlib.h>

#include <string.h>

#ifdef UNICODE_OUT  /* This variable for Obtain UTF-16 Output */

/*! In order to determine length of UTF-16 Buffer 
 * Basicall char *p should be a Utf-16 Buffer  */

UTF8_char 
strlenUnicode (char *p)
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "strlenUnicode", NULL, 1,
					TRACETYPE_STRING, 0, ((void*)&p));	  /* AUTOINSERTED TRACE */
	#endif

  UTF8_char len = 0;
  UTF8_char d;
  UTF16_char c ;
  char* s = p;
  c = *((UTF16_char *)&s[len]);
  if (c)
    {
      while (c)
	{
	  c = *((UTF16_char *)&s[len]);
	  len +=2;
	  d = s[len];
	  if(!d)
	    {
	      	{
		#ifdef ENABLE_AXISTRACE
			UTF8_char traceRet = (len);
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "strlenUnicode", NULL, 1,
					TRACETYPE_DATA, sizeof(UTF8_char), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return len;
		#endif
	}

	    break;
	    }
	}
      	{
		#ifdef ENABLE_AXISTRACE
			UTF8_char traceRet = ((len-2));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "strlenUnicode", NULL, 2,
					TRACETYPE_DATA, sizeof(UTF8_char), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return (len-2);
		#endif
	}

    }
  else 
    	{
		#ifdef ENABLE_AXISTRACE
			UTF8_char traceRet = (0);
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "strlenUnicode", NULL, 3,
					TRACETYPE_DATA, sizeof(UTF8_char), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return 0;
		#endif
	}

}

/*! To Duplicate UTF-16 string */

char * 
strdupUnicode (char* p)
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "strdupUnicode", NULL, 1,
					TRACETYPE_STRING, 0, ((void*)&p));	  /* AUTOINSERTED TRACE */
	#endif

  char *s;
  UTF8_char length;
  length = strlenUnicode (p);
  unicodeLength = length + 1;
  s = (char *)calloc (length, 1);
  	{
		#ifdef ENABLE_AXISTRACE
			char* traceRet = ((char *)memcpy (s, p, length));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "strdupUnicode", NULL, 0,
					TRACETYPE_STRING, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return (char *)memcpy (s, p, length);
		#endif
	}

}

/*!To Duplicate UTF-16 String  */

char * 
strdupUnicode (char* p, int length)
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "strdupUnicode", NULL, 2,
					TRACETYPE_STRING, 0, ((void*)&p),
					TRACETYPE_INT, 0, ((void*)&length));	  /* AUTOINSERTED TRACE */
	#endif

  char *s;
  unicodeLength = length + 1;
  s = (char *)calloc (length+1, 1);
  s[length] = 0;
  	{
		#ifdef ENABLE_AXISTRACE
			char* traceRet = ((char *)memcpy (s, p, length));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "strdupUnicode", NULL, 0,
					TRACETYPE_STRING, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return (char *)memcpy (s, p, length);
		#endif
	}

}

#endif /*end of UNICODE_OUT definition  */

