#ifdef ENABLE_AXISTRACE
/* TRACE ADDED BY THE TRACE INSTRUMENTOR TOOL */
#include "../../common/AxisTrace.h"
#endif
/* -*- C++ -*- */

/*
 *   Copyright 2003-2004 The Apache Software Foundation.
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 */

/*
 * This is the Service implementation CPP file genarated by theWSDL2Ws.
 * AxisAdminServiceWrapper.cpp: implemtation for the AxisAdminServiceWrapper.
 * 
 */

#include "AxisAdminServiceWrapper.h"

#include "../../common/IAdminUtils.h"

AxisAdminServiceWrapper::AxisAdminServiceWrapper ()
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("AxisAdminServiceWrapper", "AxisAdminServiceWrapper", this, 0);	  /* AUTOINSERTED TRACE */
	#endif


	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("AxisAdminServiceWrapper", "AxisAdminServiceWrapper", this, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

AxisAdminServiceWrapper::~AxisAdminServiceWrapper ()
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("AxisAdminServiceWrapper", "~AxisAdminServiceWrapper", this, 0);	  /* AUTOINSERTED TRACE */
	#endif


	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("AxisAdminServiceWrapper", "~AxisAdminServiceWrapper", this, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

/* Implementation of WrapperClassHandler interface */

void AxisAdminServiceWrapper::onFault (void* pMsg)
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("AxisAdminServiceWrapper", "onFault", this, 1,
					TRACETYPE_POINTER, 1, ((void*)&pMsg));	  /* AUTOINSERTED TRACE */
	#endif


	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("AxisAdminServiceWrapper", "onFault", this, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

int AxisAdminServiceWrapper::init ()
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("AxisAdminServiceWrapper", "init", this, 0);	  /* AUTOINSERTED TRACE */
	#endif

    	{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (AXIS_SUCCESS);
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("AxisAdminServiceWrapper", "init", this, 0,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return AXIS_SUCCESS;
		#endif
	}

}

int AxisAdminServiceWrapper::fini ()
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("AxisAdminServiceWrapper", "fini", this, 0);	  /* AUTOINSERTED TRACE */
	#endif

    	{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (AXIS_SUCCESS);
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("AxisAdminServiceWrapper", "fini", this, 0,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return AXIS_SUCCESS;
		#endif
	}

}

/*
 * This method invokes the right service method 
 */

int AxisAdminServiceWrapper::invoke (void* pMsg)
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("AxisAdminServiceWrapper", "invoke", this, 1,
					TRACETYPE_POINTER, 1, ((void*)&pMsg));	  /* AUTOINSERTED TRACE */
	#endif

    IMessageData* mc = (IMessageData*) pMsg;
    const AxisChar* method = mc->getOperationName ();
    if (0 == strcmp (method, "updateWSDD"))
        	{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (updateWSDD (mc));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("AxisAdminServiceWrapper", "invoke", this, 1,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return updateWSDD (mc);
		#endif
	}

    else
        	{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (AXIS_FAIL);
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("AxisAdminServiceWrapper", "invoke", this, 2,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return AXIS_FAIL;
		#endif
	}

}

/* Methods corresponding to the web service methods */

/*
 * This method wrap the service method 
 */

int AxisAdminServiceWrapper::updateWSDD (void* pMsg)
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("AxisAdminServiceWrapper", "updateWSDD", this, 1,
					TRACETYPE_POINTER, 1, ((void*)&pMsg));	  /* AUTOINSERTED TRACE */
	#endif

    IMessageData* mc = (IMessageData*) pMsg;
    int nStatus;
    IWrapperSoapSerializer* pIWSSZ = NULL;
    mc->getSoapSerializer (&pIWSSZ);
    if (!pIWSSZ)
        	{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (AXIS_FAIL);
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("AxisAdminServiceWrapper", "updateWSDD", this, 1,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return AXIS_FAIL;
		#endif
	}

    IWrapperSoapDeSerializer* pIWSDZ = NULL;
    mc->getSoapDeSerializer (&pIWSDZ);
    if (!pIWSDZ)
        	{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (AXIS_FAIL);
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("AxisAdminServiceWrapper", "updateWSDD", this, 2,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return AXIS_FAIL;
		#endif
	}

    /* check whether we have got correct message */
    if (AXIS_SUCCESS !=
        pIWSDZ->checkMessageBody ("updateWSDD", "http://www.opensource.lk/xsd"))
        	{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (AXIS_FAIL);
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("AxisAdminServiceWrapper", "updateWSDD", this, 3,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return AXIS_FAIL;
		#endif
	}

    pIWSSZ->createSoapMethod ("updateWSDDResponse",
        "http://www.opensource.lk/xsd");
    xsd__base64Binary v0 = pIWSDZ->getElementAsBase64Binary ("wsdd", 0);
    if (AXIS_SUCCESS != (nStatus = pIWSDZ->getStatus ()))
        	{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (nStatus);
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("AxisAdminServiceWrapper", "updateWSDD", this, 4,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return nStatus;
		#endif
	}

    xsd__boolean ret = false_;
    IAdminUtils* pAdminUtils;
    mc->getAdminUtils (&pAdminUtils);
    if (pAdminUtils)
    {
        if (AXIS_SUCCESS == pAdminUtils->updateWSDD ((char*) v0.__ptr))
              ret = true_;
    }
    	{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (pIWSSZ->addOutputParam ("return", (void*) &ret, XSD_BOOLEAN));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("AxisAdminServiceWrapper", "updateWSDD", this, 5,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return pIWSSZ->addOutputParam ("return", (void*) &ret, XSD_BOOLEAN);
		#endif
	}

}

