#ifdef ENABLE_AXISTRACE
/* TRACE ADDED BY THE TRACE INSTRUMENTOR TOOL */
#include "../../common/AxisTrace.h"
#endif
/* -*- C++ -*- */

/*
 *   Copyright 2003-2004 The Apache Software Foundation.
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 *
 * @author Sanjaya Singharage (sanjayas@opensource.lk, sanjayas@jkcsworld.com)
 * @author Susantha Kumara (susantha@opensource.lk, skumara@virtusa.com)
 */

#include "ApacheTransport.h"

#define xxx ap_log_rerror(APLOG_MARK,APLOG_ERR, globr,"logged here");

#define yyy ap_log_rerror(APLOG_MARK, APLOG_ERR, globr,"logged here");

/* file: mod_axis.cpp */

/* here's the content handler */

extern "C" int initialize_module (int bServer);

extern "C" int uninitialize_module ();

extern int process_request (SOAPTransport* str);

extern unsigned char chEBuf[1024];

int axis_handler_helper(request_rec* req_rec)
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axis_handler_helper", NULL, 1,
					TRACETYPE_POINTER, sizeof(request_rec), ((void*)&req_rec));	  /* AUTOINSERTED TRACE */
	#endif

    int rc;
    SOAPTransport* pTransport;
    pTransport = new ApacheTransport((void*)req_rec);
    /* for SOAP 1.2 this this should be "application/soap+xml" but keep this for
     * the moment. */
    req_rec->content_type = (M_POST == req_rec->method_number) ? 
    "text/xml" : "text/html";
    // Samisa : if it is a GET request with wsdl arg then content type should be text/xml
    if (req_rec->args)
    {
        if( strcmp("wsdl", req_rec->args) == 0 )
            req_rec->content_type = "text/xml";
    }
	 /* Set up the read policy from the client.*/
    if ((rc = ap_setup_client_block(req_rec, REQUEST_CHUNKED_ERROR)) != OK)
    {
		delete pTransport;
        	{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (rc);
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axis_handler_helper", NULL, 1,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return rc;
		#endif
	}

    }
    /* Tell the client that we are ready to receive content and check whether 
     * client will send content. control will pass to this block only if there is
     * body content in the request 
     */
	ap_should_client_block (req_rec);
    if (0 != process_request(pTransport))
    {
		delete pTransport;
        	{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (OK);
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axis_handler_helper", NULL, 2,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return OK;
		#endif
	}

    }
	delete pTransport;
    	{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (OK);
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axis_handler_helper", NULL, 3,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return OK;
		#endif
	}
	
}

/* Call initialize_module() [of Packet.h] from within this method */

extern "C"
{ 
static void module_init(server_rec* svr_rec, pool* p)
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "module_init", NULL, 2,
					TRACETYPE_POINTER, sizeof(server_rec), ((void*)&svr_rec),
					TRACETYPE_POINTER, sizeof(pool), ((void*)&p));	  /* AUTOINSERTED TRACE */
	#endif

    initialize_module (1);
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "module_init", NULL, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

/* Call initialize_process() [of Packet.h] from within this method */

static void axis_Init (server_rec* svr_rec, pool* p)
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axis_Init", NULL, 2,
					TRACETYPE_POINTER, sizeof(server_rec), ((void*)&svr_rec),
					TRACETYPE_POINTER, sizeof(pool), ((void*)&p));	  /* AUTOINSERTED TRACE */
	#endif


	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axis_Init", NULL, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

/*Call finalize_process() [of Packet.h] from within this method*/

static void axis_Fini (server_rec* svr_rec, pool* p)
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axis_Fini", NULL, 2,
					TRACETYPE_POINTER, sizeof(server_rec), ((void*)&svr_rec),
					TRACETYPE_POINTER, sizeof(pool), ((void*)&p));	  /* AUTOINSERTED TRACE */
	#endif


	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axis_Fini", NULL, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

static int axis_handler(request_rec* req_rec)
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axis_handler", NULL, 1,
					TRACETYPE_POINTER, sizeof(request_rec), ((void*)&req_rec));	  /* AUTOINSERTED TRACE */
	#endif

		{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (axis_handler_helper(req_rec));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axis_handler", NULL, 0,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return axis_handler_helper(req_rec);
		#endif
	}

}

/* Make the name of the content handler known to Apache */

static handler_rec axis_handlers[] = { {"axis", axis_handler}, {NULL} };

/* Tell Apache what phases of the transaction we handle */
 module MODULE_VAR_EXPORT axis_module = {
    STANDARD_MODULE_STUFF,
    module_init,                /* module initializer                 */
    NULL,                       /* per-directory config creator       */
    NULL,                       /* dir config merger                  */
    NULL,                       /* server config creator              */
    NULL,                       /* server config merger               */
    NULL,                       /* command table                      */
    axis_handlers,              /* [9]  content handlers              */
    NULL,                       /* [2]  URI-to-filename translation   */
    NULL,                       /* [5]  check/validate user_id        */
    NULL,                       /* [6]  check user_id is valid *here* */
    NULL,                       /* [4]  check access by host address  */
    NULL,                       /* [7]  MIME type checker/setter      */
    NULL,                       /* [8]  fixups                        */
    NULL,                       /* [10] logger                        */
    NULL,                       /* [3]  header parser                 */
    axis_Init,                  /* process initialization             */
    axis_Fini,                  /* process exit/cleanup               */
    NULL                        /* [1]  post read_request handling    */
};

}

