#ifdef ENABLE_AXISTRACE
/* TRACE ADDED BY THE TRACE INSTRUMENTOR TOOL */
#include "../../common/AxisTrace.h"
#endif
/*
 *   Copyright 2003-2004 The Apache Software Foundation.
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 *
 *  @author Dinesh Premalal (xydinesh@gmail.com
 *			     premalal@opensource.lk)
 *
 */

#include "AxisInputStream.hpp"

AxisInputStream::AxisInputStream (AxisIOStream* pInputStream)
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("AxisInputStream", "AxisInputStream", this, 1,
					TRACETYPE_POINTER, sizeof(AxisIOStream), ((void*)&pInputStream));	  /* AUTOINSERTED TRACE */
	#endif

  m_pInputStream = pInputStream ;
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("AxisInputStream", "AxisInputStream", this, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

AxisInputStream::~AxisInputStream ()
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("AxisInputStream", "~AxisInputStream", this, 0);	  /* AUTOINSERTED TRACE */
	#endif


	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("AxisInputStream", "~AxisInputStream", this, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

int
AxisInputStream::read (char* buffer, int offset, int length)
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("AxisInputStream", "read", this, 3,
					TRACETYPE_STRING, 0, ((void*)&buffer),
					TRACETYPE_INT, 0, ((void*)&offset),
					TRACETYPE_INT, 0, ((void*)&length));	  /* AUTOINSERTED TRACE */
	#endif

  int size = length;
  m_pInputStream->getBytes (buffer+offset, &size);
  	{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (size);
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("AxisInputStream", "read", this, 0,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return size;
		#endif
	}

}

